/*
 * This file was generated automatically by xsubpp version 1.9507 from the 
 * contents of Imager.xs. Do not edit this file, edit Imager.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Imager.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "ppport.h"
#ifdef __cplusplus
}
#endif

#include "image.h"
#include "feat.h"
#include "dynaload.h"
#include "regmach.h"

typedef i_color* Imager__Color;
typedef i_img* Imager__ImgRaw;

#ifdef HAVE_LIBTT
typedef TT_Fonthandle* Imager__TTHandle;
#endif

typedef struct i_reader_data_tag
{
  /* presumably a CODE ref or name of a sub */
  SV *sv;
} i_reader_data;

/* used by functions that want callbacks */
static int read_callback(char *userdata, char *buffer, int need, int want) {
  i_reader_data *rd = (i_reader_data *)userdata;
  int count;
  int result;
  SV *data;
  dSP; dTARG = sv_newmortal();
  /* thanks to Simon Cozens for help with the dTARG above */

  ENTER;
  SAVETMPS;
  EXTEND(SP, 2);
  PUSHMARK(SP);
  PUSHi(want);
  PUSHi(need);
  PUTBACK;

  count = perl_call_sv(rd->sv, G_SCALAR);

  SPAGAIN;

  if (count != 1)
    croak("Result of perl_call_sv(..., G_SCALAR) != 1");

  data = POPs;

  if (SvOK(data)) {
    STRLEN len;
    char *ptr = SvPV(data, len);
    if (len > want)
      croak("Too much data returned in reader callback");
    
    memcpy(buffer, ptr, len);
    result = len;
  }
  else {
    result = -1;
  }

  PUTBACK;
  FREETMPS;
  LEAVE;

  return result;
}

typedef struct
{
  SV *sv; /* a coderef or sub name */
} i_writer_data;

/* used by functions that want callbacks */
static int write_callback(char *userdata, char const *data, int size) {
  i_writer_data *wd = (i_writer_data *)userdata;
  int count;
  int success;
  SV *sv;
  dSP; 

  ENTER;
  SAVETMPS;
  EXTEND(SP, 1);
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSVpv((char *)data, size)));
  PUTBACK;

  count = perl_call_sv(wd->sv, G_SCALAR);

  SPAGAIN;

  if (count != 1)
    croak("Result of perl_call_sv(..., G_SCALAR) != 1");

  sv = POPs;
  success = SvTRUE(sv);


  PUTBACK;
  FREETMPS;
  LEAVE;

  return success;
}

struct value_name {
  char *name;
  int value;
};
static int lookup_name(struct value_name *names, int count, char *name, int def_value)
{
  int i;
  for (i = 0; i < count; ++i)
    if (strEQ(names[i].name, name))
      return names[i].value;

  return def_value;
}
static struct value_name transp_names[] =
{
  { "none", tr_none },
  { "threshold", tr_threshold },
  { "errdiff", tr_errdiff },
  { "ordered", tr_ordered, },
};

static struct value_name make_color_names[] =
{
  { "none", mc_none, },
  { "webmap", mc_web_map, },
  { "addi", mc_addi, },
};

static struct value_name translate_names[] =
{
#ifdef HAVE_LIBGIF
  { "giflib", pt_giflib, },
#endif
  { "closest", pt_closest, },
  { "perturb", pt_perturb, },
  { "errdiff", pt_errdiff, },
};

static struct value_name errdiff_names[] =
{
  { "floyd", ed_floyd, },
  { "jarvis", ed_jarvis, },
  { "stucki", ed_stucki, },
  { "custom", ed_custom, },
};

static struct value_name orddith_names[] =
{
  { "random", od_random, },
  { "dot8", od_dot8, },
  { "dot4", od_dot4, },
  { "hline", od_hline, },
  { "vline", od_vline, },
  { "/line", od_slashline, },
  { "slashline", od_slashline, },
  { "\\line", od_backline, },
  { "backline", od_backline, },
  { "custom", od_custom, },
};

/* look through the hash for quantization options */
static void handle_quant_opts(i_quantize *quant, HV *hv)
{
  /*** POSSIBLY BROKEN: do I need to unref the SV from hv_fetch ***/
  SV **sv;
  int i;
  STRLEN len;
  char *str;

  sv = hv_fetch(hv, "transp", 6, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->transp = 
      lookup_name(transp_names, sizeof(transp_names)/sizeof(*transp_names), 
		  str, tr_none);
    if (quant->transp != tr_none) {
      quant->tr_threshold = 127;
      sv = hv_fetch(hv, "tr_threshold", 12, 0);
      if (sv && *sv)
	quant->tr_threshold = SvIV(*sv);
    }
    if (quant->transp == tr_errdiff) {
      sv = hv_fetch(hv, "tr_errdiff", 10, 0);
      if (sv && *sv && (str = SvPV(*sv, len)))
	quant->tr_errdiff = lookup_name(errdiff_names, sizeof(errdiff_names)/sizeof(*errdiff_names), str, ed_floyd);
    }
    if (quant->transp == tr_ordered) {
      quant->tr_orddith = od_random;
      sv = hv_fetch(hv, "tr_orddith", 10, 0);
      if (sv && *sv && (str = SvPV(*sv, len)))
	quant->tr_orddith = lookup_name(orddith_names, sizeof(orddith_names)/sizeof(*orddith_names), str, od_random);

      if (quant->tr_orddith == od_custom) {
	sv = hv_fetch(hv, "tr_map", 6, 0);
	if (sv && *sv && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
	  AV *av = (AV*)SvRV(*sv);
	  len = av_len(av) + 1;
	  if (len > sizeof(quant->tr_custom))
	    len = sizeof(quant->tr_custom);
	  for (i = 0; i < len; ++i) {
	    SV **sv2 = av_fetch(av, i, 0);
	    if (sv2 && *sv2) {
	      quant->tr_custom[i] = SvIV(*sv2);
	    }
	  }
	  while (i < sizeof(quant->tr_custom))
	    quant->tr_custom[i++] = 0;
	}
      }
    }
  }
  quant->make_colors = mc_addi;
  sv = hv_fetch(hv, "make_colors", 11, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->make_colors = 
      lookup_name(make_color_names, sizeof(make_color_names)/sizeof(*make_color_names), str, mc_addi);
  }
  sv = hv_fetch(hv, "colors", 6, 0);
  if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
    /* needs to be an array of Imager::Color
       note that the caller allocates the mc_color array and sets mc_size
       to it's size */
    AV *av = (AV *)SvRV(*sv);
    quant->mc_count = av_len(av)+1;
    if (quant->mc_count > quant->mc_size)
      quant->mc_count = quant->mc_size;
    for (i = 0; i < quant->mc_count; ++i) {
      SV **sv1 = av_fetch(av, i, 0);
      if (sv1 && *sv1 && SvROK(*sv1) && sv_derived_from(*sv1, "Imager::Color")) {
	i_color *col = (i_color *)SvIV((SV*)SvRV(*sv1));
	quant->mc_colors[i] = *col;
      }
    }
  }
  sv = hv_fetch(hv, "max_colors", 10, 0);
  if (sv && *sv) {
    i = SvIV(*sv);
    if (i <= quant->mc_size && i >= quant->mc_count)
      quant->mc_size = i;
  }

  quant->translate = pt_closest;
  sv = hv_fetch(hv, "translate", 9, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->translate = lookup_name(translate_names, sizeof(translate_names)/sizeof(*translate_names), str, pt_closest);
  }
  sv = hv_fetch(hv, "errdiff", 7, 0);
  if (sv && *sv && (str = SvPV(*sv, len))) {
    quant->errdiff = lookup_name(errdiff_names, sizeof(errdiff_names)/sizeof(*errdiff_names), str, ed_floyd);
  }
  if (quant->translate == pt_errdiff && quant->errdiff == ed_custom) {
    /* get the error diffusion map */
    sv = hv_fetch(hv, "errdiff_width", 13, 0);
    if (sv && *sv)
      quant->ed_width = SvIV(*sv);
    sv = hv_fetch(hv, "errdiff_height", 14, 0);
    if (sv && *sv)
      quant->ed_height = SvIV(*sv);
    if (quant->ed_width > 0 && quant->ed_height > 0) {
      int sum = 0;
      quant->ed_map = mymalloc(sizeof(int)*quant->ed_width*quant->ed_height);
      sv = hv_fetch(hv, "errdiff_map", 11, 0);
      if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
	AV *av = (AV*)SvRV(*sv);
	len = av_len(av) + 1;
	if (len > quant->ed_width * quant->ed_height)
	  len = quant->ed_width * quant->ed_height;
	for (i = 0; i < len; ++i) {
	  SV **sv2 = av_fetch(av, i, 0);
	  if (sv2 && *sv2) {
	    quant->ed_map[i] = SvIV(*sv2);
	    sum += quant->ed_map[i];
	  }
	}
      }
      if (!sum) {
	/* broken map */
	myfree(quant->ed_map);
	quant->ed_map = 0;
	quant->errdiff = ed_floyd;
      }
    }
  }
  sv = hv_fetch(hv, "perturb", 7, 0);
  if (sv && *sv)
    quant->perturb = SvIV(*sv);
}

/* look through the hash for options to add to opts */
static void handle_gif_opts(i_gif_opts *opts, HV *hv)
{
  /*** POSSIBLY BROKEN: do I need to unref the SV from hv_fetch? ***/
  SV **sv;
  int i;
  /**((char *)0) = '\0';*/
  sv = hv_fetch(hv, "gif_each_palette", 16, 0);
  if (sv && *sv)
    opts->each_palette = SvIV(*sv);
  sv = hv_fetch(hv, "interlace", 9, 0);
  if (sv && *sv)
    opts->interlace = SvIV(*sv);
  sv = hv_fetch(hv, "gif_delays", 10, 0);
  if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
    AV *av = (AV*)SvRV(*sv);
    opts->delay_count = av_len(av)+1;
    opts->delays = mymalloc(sizeof(int) * opts->delay_count);
    for (i = 0; i < opts->delay_count; ++i) {
      SV *sv1 = *av_fetch(av, i, 0);
      opts->delays[i] = SvIV(sv1);
    }
  }
  sv = hv_fetch(hv, "gif_user_input", 14, 0);
  if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
    AV *av = (AV*)SvRV(*sv);
    opts->user_input_count = av_len(av)+1;
    opts->user_input_flags = mymalloc(opts->user_input_count);
    for (i = 0; i < opts->user_input_count; ++i) {
      SV *sv1 = *av_fetch(av, i, 0);
      opts->user_input_flags[i] = SvIV(sv1) != 0;
    }
  }
  sv = hv_fetch(hv, "gif_disposal", 12, 0);
  if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
    AV *av = (AV*)SvRV(*sv);
    opts->disposal_count = av_len(av)+1;
    opts->disposal = mymalloc(opts->disposal_count);
    for (i = 0; i < opts->disposal_count; ++i) {
      SV *sv1 = *av_fetch(av, i, 0);
      opts->disposal[i] = SvIV(sv1);
    }
  }
  sv = hv_fetch(hv, "gif_tran_color", 14, 0);
  if (sv && *sv && SvROK(*sv) && sv_derived_from(*sv, "Imager::Color")) {
    i_color *col = (i_color *)SvIV((SV *)SvRV(*sv));
    opts->tran_color = *col;
  }
  sv = hv_fetch(hv, "gif_positions", 13, 0);
  if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
    AV *av = (AV *)SvRV(*sv);
    opts->position_count = av_len(av) + 1;
    opts->positions = mymalloc(sizeof(i_gif_pos) * opts->position_count);
    for (i = 0; i < opts->position_count; ++i) {
      SV **sv2 = av_fetch(av, i, 0);
      opts->positions[i].x = opts->positions[i].y = 0;
      if (sv && *sv && SvROK(*sv) && SvTYPE(SvRV(*sv)) == SVt_PVAV) {
	AV *av2 = (AV*)SvRV(*sv2);
	SV **sv3;
	sv3 = av_fetch(av2, 0, 0);
	if (sv3 && *sv3)
	  opts->positions[i].x = SvIV(*sv3);
	sv3 = av_fetch(av2, 1, 0);
	if (sv3 && *sv3)
	  opts->positions[i].y = SvIV(*sv3);
      }	
    }	
  }
  /* Netscape2.0 loop count extension */
  sv = hv_fetch(hv, "gif_loop_count", 14, 0);
  if (sv && *sv)
    opts->loop_count = SvIV(*sv);
}

/* copies the color map from the hv into the colors member of the HV */
static void copy_colors_back(HV *hv, i_quantize *quant) {
  SV **sv;
  AV *av;
  int i;
  SV *work;

  sv = hv_fetch(hv, "colors", 6, 0);
  if (!sv || !*sv || !SvROK(*sv) || SvTYPE(SvRV(*sv)) != SVt_PVAV) {
    SV *ref;
    av = newAV();
    ref = newRV_inc((SV*) av);
    sv = hv_store(hv, "colors", 6, ref, 0);
  }
  else {
    av = (AV *)SvRV(*sv);
  }
  av_extend(av, quant->mc_count+1);
  work = sv_newmortal();
  for (i = 0; i < quant->mc_count; ++i) {
    i_color *in = quant->mc_colors+i;
    Imager__Color c = i_color_new(in->rgb.r, in->rgb.g, in->rgb.b, 255);
    sv_setref_pv(work, "Imager::Color", (void *)c);
    av_store(av, i, work);
  }
}

/* used to make the typemap happy */
typedef HV *HASH;

#line 415 "Imager.c"
XS(XS_Imager__Color_DESTROY)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::Color::DESTROY(cl)");
    {
	Imager__Color	cl;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = (Imager__Color) tmp;
	}
	else
	    croak("cl is not a reference");

	ICL_DESTROY(cl);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager__ImgRaw_new)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::ImgRaw::new(x,y,ch)");
    {
	int	x = (int)SvIV(ST(0));
	int	y = (int)SvIV(ST(1));
	int	ch = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	RETVAL = IIM_new(x, y, ch);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager__ImgRaw_DESTROY)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::ImgRaw::DESTROY(im)");
    {
	Imager__ImgRaw	im;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not a reference");

	IIM_DESTROY(im);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_color_new)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_color_new(r,g,b,a)");
    {
	unsigned char	r = (unsigned char)SvUV(ST(0));
	unsigned char	g = (unsigned char)SvUV(ST(1));
	unsigned char	b = (unsigned char)SvUV(ST(2));
	unsigned char	a = (unsigned char)SvUV(ST(3));
	Imager__Color	RETVAL;

	RETVAL = i_color_new(r, g, b, a);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_color_set)
{
    dXSARGS;
    if (items != 5)
	croak("Usage: Imager::i_color_set(cl,r,g,b,a)");
    {
	Imager__Color	cl;
	unsigned char	r = (unsigned char)SvUV(ST(1));
	unsigned char	g = (unsigned char)SvUV(ST(2));
	unsigned char	b = (unsigned char)SvUV(ST(3));
	unsigned char	a = (unsigned char)SvUV(ST(4));
	Imager__Color	RETVAL;

	if (sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = (Imager__Color) tmp;
	}
	else
	    croak("cl is not of type Imager::Color");

	RETVAL = i_color_set(cl, r, g, b, a);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::Color", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_color_info)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_color_info(cl)");
    {
	Imager__Color	cl;

	if (sv_derived_from(ST(0), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    cl = (Imager__Color) tmp;
	}
	else
	    croak("cl is not of type Imager::Color");

	i_color_info(cl);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_list_formats)
{
    dXSARGS;
    if (items != 0)
	croak("Usage: Imager::i_list_formats()");
    SP -= items;
    {
#line 453 "Imager.xs"
	      char*    item;
	       int     i;
#line 550 "Imager.c"
#line 456 "Imager.xs"
	       i=0;
	       while( (item=i_format_list[i++]) != NULL ) {
		      EXTEND(SP, 1);
		      PUSHs(sv_2mortal(newSVpv(item,0)));
	       }
#line 557 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_has_format)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_has_format(frmt)");
    {
	char*	frmt = (char *)SvPV(ST(0),PL_na);
	undef_int	RETVAL;

	RETVAL = i_has_format(frmt);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_img_new)
{
    dXSARGS;
    if (items != 0)
	croak("Usage: Imager::i_img_new()");
    {
	Imager__ImgRaw	RETVAL;

	RETVAL = i_img_new();
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_img_empty)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::i_img_empty(im,x,y)");
    {
	Imager__ImgRaw	im;
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_img_empty(im, x, y);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_img_empty_ch)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_img_empty_ch(im,x,y,ch)");
    {
	Imager__ImgRaw	im;
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	int	ch = (int)SvIV(ST(3));
	Imager__ImgRaw	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_img_empty_ch(im, x, y, ch);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_init_log)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::init_log(name,onoff)");
    {
	char*	name = (char *)SvPV(ST(0),PL_na);
	int	onoff = (int)SvIV(ST(1));

	init_log(name, onoff);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_img_exorcise)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_img_exorcise(im)");
    {
	Imager__ImgRaw	im;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_img_exorcise(im);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_img_destroy)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_img_destroy(im)");
    {
	Imager__ImgRaw	im;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_img_destroy(im);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_img_info)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_img_info(im)");
    SP -= items;
    {
	Imager__ImgRaw	im;
#line 499 "Imager.xs"
	       int     info[4];
#line 710 "Imager.c"

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");
#line 501 "Imager.xs"
   	       i_img_info(im,info);
               EXTEND(SP, 4);
               PUSHs(sv_2mortal(newSViv(info[0])));
               PUSHs(sv_2mortal(newSViv(info[1])));
               PUSHs(sv_2mortal(newSViv(info[2])));
               PUSHs(sv_2mortal(newSViv(info[3])));
#line 725 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_img_setmask)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_img_setmask(im,ch_mask)");
    {
	Imager__ImgRaw	im;
	int	ch_mask = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_img_setmask(im, ch_mask);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_img_getmask)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_img_getmask(im)");
    {
	Imager__ImgRaw	im;
	int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_img_getmask(im);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_img_getchannels)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_img_getchannels(im)");
    {
	Imager__ImgRaw	im;
	int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_img_getchannels(im);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_draw)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_draw(im,x1,y1,x2,y2,val)");
    {
	Imager__ImgRaw	im;
	int	x1 = (int)SvIV(ST(1));
	int	y1 = (int)SvIV(ST(2));
	int	x2 = (int)SvIV(ST(3));
	int	y2 = (int)SvIV(ST(4));
	Imager__Color	val;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");

	i_draw(im, x1, y1, x2, y2, val);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_line_aa)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_line_aa(im,x1,y1,x2,y2,val)");
    {
	Imager__ImgRaw	im;
	int	x1 = (int)SvIV(ST(1));
	int	y1 = (int)SvIV(ST(2));
	int	x2 = (int)SvIV(ST(3));
	int	y2 = (int)SvIV(ST(4));
	Imager__Color	val;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");

	i_line_aa(im, x1, y1, x2, y2, val);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_box)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_box(im,x1,y1,x2,y2,val)");
    {
	Imager__ImgRaw	im;
	int	x1 = (int)SvIV(ST(1));
	int	y1 = (int)SvIV(ST(2));
	int	x2 = (int)SvIV(ST(3));
	int	y2 = (int)SvIV(ST(4));
	Imager__Color	val;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");

	i_box(im, x1, y1, x2, y2, val);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_box_filled)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_box_filled(im,x1,y1,x2,y2,val)");
    {
	Imager__ImgRaw	im;
	int	x1 = (int)SvIV(ST(1));
	int	y1 = (int)SvIV(ST(2));
	int	x2 = (int)SvIV(ST(3));
	int	y2 = (int)SvIV(ST(4));
	Imager__Color	val;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(5), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(5)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");

	i_box_filled(im, x1, y1, x2, y2, val);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_arc)
{
    dXSARGS;
    if (items != 7)
	croak("Usage: Imager::i_arc(im,x,y,rad,d1,d2,val)");
    {
	Imager__ImgRaw	im;
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	float	rad = (float)SvNV(ST(3));
	float	d1 = (float)SvNV(ST(4));
	float	d2 = (float)SvNV(ST(5));
	Imager__Color	val;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(6), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(6)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");

	i_arc(im, x, y, rad, d1, d2, val);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_bezier_multi)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_bezier_multi(im,xc,yc,val)");
    SP -= items;
    {
	Imager__ImgRaw	im;
	Imager__Color	val;
#line 575 "Imager.xs"
	     double   *x,*y;
	     int       len;
	     AV       *av1;
	     AV       *av2;
	     SV       *sv1;
	     SV       *sv2;
	     int i;
#line 976 "Imager.c"

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");
#line 583 "Imager.xs"
	     i_color_info(val);
	     if (!SvROK(ST(1))) croak("Imager: Parameter 1 to i_bezier_multi must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 to i_bezier_multi must be a reference to an array\n");
	     if (!SvROK(ST(2))) croak("Imager: Parameter 2 to i_bezier_multi must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 2 to i_bezier_multi must be a reference to an array\n");
	     av1=(AV*)SvRV(ST(1));
	     av2=(AV*)SvRV(ST(2));
	     if (av_len(av1) != av_len(av2)) croak("Imager: x and y arrays to i_bezier_multi must be equal length\n");
	     len=av_len(av1)+1;
	     x=mymalloc( len*sizeof(double) );
	     y=mymalloc( len*sizeof(double) );
	     for(i=0;i<len;i++) {
	       sv1=(*(av_fetch(av1,i,0)));
	       sv2=(*(av_fetch(av2,i,0)));
	       x[i]=(double)SvNV(sv1);
	       y[i]=(double)SvNV(sv2);
	     }
             i_bezier_multi(im,len,x,y,val);
             myfree(x);
             myfree(y);
#line 1012 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_poly_aa)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_poly_aa(im,xc,yc,val)");
    SP -= items;
    {
	Imager__ImgRaw	im;
	Imager__Color	val;
#line 610 "Imager.xs"
	     double   *x,*y;
	     int       len;
	     AV       *av1;
	     AV       *av2;
	     SV       *sv1;
	     SV       *sv2;
	     int i;
#line 1035 "Imager.c"

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    val = (Imager__Color) tmp;
	}
	else
	    croak("val is not of type Imager::Color");
#line 618 "Imager.xs"
	     i_color_info(val);
	     if (!SvROK(ST(1))) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     if (!SvROK(ST(2))) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 1 to i_poly_aa must be a reference to an array\n");
	     av1=(AV*)SvRV(ST(1));
	     av2=(AV*)SvRV(ST(2));
	     if (av_len(av1) != av_len(av2)) croak("Imager: x and y arrays to i_poly_aa must be equal length\n");
	     len=av_len(av1)+1;
	     x=mymalloc( len*sizeof(double) );
	     y=mymalloc( len*sizeof(double) );
	     for(i=0;i<len;i++) {
	       sv1=(*(av_fetch(av1,i,0)));
	       sv2=(*(av_fetch(av2,i,0)));
	       x[i]=(double)SvNV(sv1);
	       y[i]=(double)SvNV(sv2);
	     }
             i_poly_aa(im,len,x,y,val);
             myfree(x);
             myfree(y);
#line 1071 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_flood_fill)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_flood_fill(im,seedx,seedy,dcol)");
    {
	Imager__ImgRaw	im;
	int	seedx = (int)SvIV(ST(1));
	int	seedy = (int)SvIV(ST(2));
	Imager__Color	dcol;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    dcol = (Imager__Color) tmp;
	}
	else
	    croak("dcol is not of type Imager::Color");

	i_flood_fill(im, seedx, seedy, dcol);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_copyto)
{
    dXSARGS;
    if (items != 8)
	croak("Usage: Imager::i_copyto(im,src,x1,y1,x2,y2,tx,ty)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;
	int	x1 = (int)SvIV(ST(2));
	int	y1 = (int)SvIV(ST(3));
	int	x2 = (int)SvIV(ST(4));
	int	y2 = (int)SvIV(ST(5));
	int	tx = (int)SvIV(ST(6));
	int	ty = (int)SvIV(ST(7));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    src = (Imager__ImgRaw) tmp;
	}
	else
	    croak("src is not of type Imager::ImgRaw");

	i_copyto(im, src, x1, y1, x2, y2, tx, ty);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_copyto_trans)
{
    dXSARGS;
    if (items != 9)
	croak("Usage: Imager::i_copyto_trans(im,src,x1,y1,x2,y2,tx,ty,trans)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;
	int	x1 = (int)SvIV(ST(2));
	int	y1 = (int)SvIV(ST(3));
	int	x2 = (int)SvIV(ST(4));
	int	y2 = (int)SvIV(ST(5));
	int	tx = (int)SvIV(ST(6));
	int	ty = (int)SvIV(ST(7));
	Imager__Color	trans;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    src = (Imager__ImgRaw) tmp;
	}
	else
	    croak("src is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(8), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(8)));
	    trans = (Imager__Color) tmp;
	}
	else
	    croak("trans is not of type Imager::Color");

	i_copyto_trans(im, src, x1, y1, x2, y2, tx, ty, trans);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_copy)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_copy(im,src)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    src = (Imager__ImgRaw) tmp;
	}
	else
	    croak("src is not of type Imager::ImgRaw");

	i_copy(im, src);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_rubthru)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_rubthru(im,src,tx,ty)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	src;
	int	tx = (int)SvIV(ST(2));
	int	ty = (int)SvIV(ST(3));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    src = (Imager__ImgRaw) tmp;
	}
	else
	    croak("src is not of type Imager::ImgRaw");

	i_rubthru(im, src, tx, ty);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_gaussian)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_gaussian(im,stdev)");
    {
	Imager__ImgRaw	im;
	float	stdev = (float)SvNV(ST(1));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_gaussian(im, stdev);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_conv)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_conv(im,pcoef)");
    SP -= items;
    {
	Imager__ImgRaw	im;
#line 696 "Imager.xs"
	     float*    coeff;
	     int     len;
	     AV* av;
	     SV* sv1;
	     int i;
#line 1276 "Imager.c"

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");
#line 702 "Imager.xs"
	     if (!SvROK(ST(1))) croak("Imager: Parameter 1 must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 must be a reference to an array\n");
	     av=(AV*)SvRV(ST(1));
	     len=av_len(av)+1;
	     coeff=mymalloc( len*sizeof(float) );
	     for(i=0;i<len;i++) {
	       sv1=(*(av_fetch(av,i,0)));
	       coeff[i]=(float)SvNV(sv1);
	     }
	     i_conv(im,coeff,len);
	     myfree(coeff);
#line 1296 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_img_diff)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_img_diff(im1,im2)");
    {
	Imager__ImgRaw	im1;
	Imager__ImgRaw	im2;
	float	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im1 = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im1 is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    im2 = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im2 is not of type Imager::ImgRaw");

	RETVAL = i_img_diff(im1, im2);
	ST(0) = sv_newmortal();
	sv_setnv(ST(0), (double)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_init_fonts)
{
    dXSARGS;
    if (items != 0)
	croak("Usage: Imager::i_init_fonts()");
    {
	undef_int	RETVAL;

	RETVAL = i_init_fonts();
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef HAVE_LIBT1
#define XSubPPtmpAAAA 1

XS(XS_Imager_i_t1_set_aa)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_t1_set_aa(st)");
    {
	int	st = (int)SvIV(ST(0));

	i_t1_set_aa(st);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_t1_new)
{
    dXSARGS;
    if (items < 1 || items > 2)
	croak("Usage: Imager::i_t1_new(pfb,afm=NULL)");
    {
	char*	pfb = (char *)SvPV(ST(0),PL_na);
	char*	afm;
	int	RETVAL;

	if (items < 2)
	    afm = NULL;
	else {
	    afm = (char *)SvPV(ST(1),PL_na);
	}

	RETVAL = i_t1_new(pfb, afm);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_t1_destroy)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_t1_destroy(font_id)");
    {
	int	font_id = (int)SvIV(ST(0));
	int	RETVAL;

	RETVAL = i_t1_destroy(font_id);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_t1_cp)
{
    dXSARGS;
    if (items != 9)
	croak("Usage: Imager::i_t1_cp(im,xb,yb,channel,fontnum,points,str,len,align)");
    {
	Imager__ImgRaw	im;
	int	xb = (int)SvIV(ST(1));
	int	yb = (int)SvIV(ST(2));
	int	channel = (int)SvIV(ST(3));
	int	fontnum = (int)SvIV(ST(4));
	float	points = (float)SvNV(ST(5));
	char*	str = (char *)SvPV(ST(6),PL_na);
	int	len = (int)SvIV(ST(7));
	int	align = (int)SvIV(ST(8));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_t1_cp(im, xb, yb, channel, fontnum, points, str, len, align);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_t1_bbox)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_t1_bbox(fontnum,point,str,len)");
    SP -= items;
    {
	int	fontnum = (int)SvIV(ST(0));
	float	point = (float)SvNV(ST(1));
	char*	str = (char *)SvPV(ST(2),PL_na);
	int	len = (int)SvIV(ST(3));
#line 760 "Imager.xs"
	       int     cords[4];
#line 1449 "Imager.c"
#line 762 "Imager.xs"
   	       i_t1_bbox(fontnum,point,str,len,cords);
               EXTEND(SP, 4);
               PUSHs(sv_2mortal(newSViv(cords[0])));
               PUSHs(sv_2mortal(newSViv(cords[1])));
               PUSHs(sv_2mortal(newSViv(cords[2])));
               PUSHs(sv_2mortal(newSViv(cords[3])));
#line 1457 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_t1_text)
{
    dXSARGS;
    if (items != 9)
	croak("Usage: Imager::i_t1_text(im,xb,yb,cl,fontnum,points,str,len,align)");
    {
	Imager__ImgRaw	im;
	int	xb = (int)SvIV(ST(1));
	int	yb = (int)SvIV(ST(2));
	Imager__Color	cl;
	int	fontnum = (int)SvIV(ST(4));
	float	points = (float)SvNV(ST(5));
	char*	str = (char *)SvPV(ST(6),PL_na);
	int	len = (int)SvIV(ST(7));
	int	align = (int)SvIV(ST(8));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(3), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(3)));
	    cl = (Imager__Color) tmp;
	}
	else
	    croak("cl is not of type Imager::Color");

	RETVAL = i_t1_text(im, xb, yb, cl, fontnum, points, str, len, align);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

#endif 
#ifdef HAVE_LIBTT
#define XSubPPtmpAAAB 1

XS(XS_Imager_i_tt_new)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_tt_new(fontname)");
    {
	char*	fontname = (char *)SvPV(ST(0),PL_na);
	Imager__TTHandle	RETVAL;

	RETVAL = i_tt_new(fontname);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::TTHandle", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_tt_destroy)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_tt_destroy(handle)");
    {
	Imager__TTHandle	handle;

	if (sv_derived_from(ST(0), "Imager::TTHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = (Imager__TTHandle) tmp;
	}
	else
	    croak("handle is not of type Imager::TTHandle");

	i_tt_destroy(handle);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_tt_text)
{
    dXSARGS;
    if (items != 9)
	croak("Usage: Imager::i_tt_text(handle,im,xb,yb,cl,points,str,len,smooth)");
    {
	Imager__TTHandle	handle;
	Imager__ImgRaw	im;
	int	xb = (int)SvIV(ST(2));
	int	yb = (int)SvIV(ST(3));
	Imager__Color	cl;
	float	points = (float)SvNV(ST(5));
	char*	str = (char *)SvPV(ST(6),PL_na);
	int	len = (int)SvIV(ST(7));
	int	smooth = (int)SvIV(ST(8));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::TTHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = (Imager__TTHandle) tmp;
	}
	else
	    croak("handle is not of type Imager::TTHandle");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(4), "Imager::Color")) {
	    IV tmp = SvIV((SV*)SvRV(ST(4)));
	    cl = (Imager__Color) tmp;
	}
	else
	    croak("cl is not of type Imager::Color");

	RETVAL = i_tt_text(handle, im, xb, yb, cl, points, str, len, smooth);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_tt_cp)
{
    dXSARGS;
    if (items != 9)
	croak("Usage: Imager::i_tt_cp(handle,im,xb,yb,channel,points,str,len,smooth)");
    {
	Imager__TTHandle	handle;
	Imager__ImgRaw	im;
	int	xb = (int)SvIV(ST(2));
	int	yb = (int)SvIV(ST(3));
	int	channel = (int)SvIV(ST(4));
	float	points = (float)SvNV(ST(5));
	char*	str = (char *)SvPV(ST(6),PL_na);
	int	len = (int)SvIV(ST(7));
	int	smooth = (int)SvIV(ST(8));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::TTHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = (Imager__TTHandle) tmp;
	}
	else
	    croak("handle is not of type Imager::TTHandle");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_tt_cp(handle, im, xb, yb, channel, points, str, len, smooth);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_tt_bbox)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_tt_bbox(handle,point,str,len)");
    SP -= items;
    {
	Imager__TTHandle	handle;
	float	point = (float)SvNV(ST(1));
	char*	str = (char *)SvPV(ST(2),PL_na);
	int	len = (int)SvIV(ST(3));
#line 832 "Imager.xs"
	       int     cords[4],rc;
#line 1640 "Imager.c"
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::TTHandle")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    handle = (Imager__TTHandle) tmp;
	}
	else
	    croak("handle is not of type Imager::TTHandle");
#line 834 "Imager.xs"
  	       if (rc=i_tt_bbox(handle,point,str,len,cords)) {
                 EXTEND(SP, 4);
                 PUSHs(sv_2mortal(newSViv(cords[0])));
                 PUSHs(sv_2mortal(newSViv(cords[1])));
                 PUSHs(sv_2mortal(newSViv(cords[2])));
                 PUSHs(sv_2mortal(newSViv(cords[3])));
               }
#line 1657 "Imager.c"
	PUTBACK;
	return;
    }
}

#endif 
#ifdef HAVE_LIBJPEG
#define XSubPPtmpAAAC 1

XS(XS_Imager_i_writejpeg)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::i_writejpeg(im,fd,qfactor)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	int	qfactor = (int)SvIV(ST(2));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_writejpeg(im, fd, qfactor);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_readjpeg)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_readjpeg(fd)");
    SP -= items;
    {
	int	fd = (int)SvIV(ST(0));
#line 859 "Imager.xs"
	      char*    iptc_itext;
	       int     tlength;
	     i_img*    rimg;
                SV*    r;
#line 1706 "Imager.c"
#line 864 "Imager.xs"
 	      iptc_itext=NULL;
	      rimg=i_readjpeg(fd,&iptc_itext,&tlength);
	      if (iptc_itext == NULL) {
		    r = sv_newmortal();
	            EXTEND(SP,1);
	            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
 		    PUSHs(r);
	      } else {
		    r = sv_newmortal();
	            EXTEND(SP,2);
	            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
 		    PUSHs(r);
		    PUSHs(sv_2mortal(newSVpv(iptc_itext,tlength)));
                    myfree(iptc_itext);
	      }
#line 1723 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_readjpeg_scalar)
{
    dXSARGS;
    SP -= items;
    {
#line 885 "Imager.xs"
	      char*    data;
	       int     length;
	      char*    iptc_itext;
	       int     tlength;
	     i_img*    rimg;
                SV*    r;
#line 1741 "Imager.c"
#line 892 "Imager.xs"
 	      iptc_itext=NULL;
              data = (char *)SvPV(ST(0),length);
	      rimg=i_readjpeg_scalar(data,length,&iptc_itext,&tlength);
	      mm_log((1,"i_readjpeg_scalar: 0x%08X\n",rimg));
	      if (iptc_itext == NULL) {
		    r = sv_newmortal();
	            EXTEND(SP,1);
	            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
 		    PUSHs(r);
	      } else {
		    r = sv_newmortal();
	            EXTEND(SP,2);
	            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
 		    PUSHs(r);
		    PUSHs(sv_2mortal(newSVpv(iptc_itext,tlength)));
                    myfree(iptc_itext);
	      }
#line 1760 "Imager.c"
	PUTBACK;
	return;
    }
}

#endif
#ifdef HAVE_LIBPNG
#define XSubPPtmpAAAD 1

XS(XS_Imager_i_readpng)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_readpng(fd)");
    {
	int	fd = (int)SvIV(ST(0));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_readpng(fd);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writepng)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_writepng(im,fd)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_writepng(im, fd);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_readpng_scalar)
{
    dXSARGS;
    {
#line 937 "Imager.xs"
	      char*    data;
	       int     length;
#line 1818 "Imager.c"
	Imager__ImgRaw	RETVAL;
#line 940 "Imager.xs"
              data = (char *)SvPV(ST(0),length);
 	      RETVAL=i_readpng_scalar(data,length);
#line 1823 "Imager.c"
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef HAVE_LIBGIF
#define XSubPPtmpAAAE 1

XS(XS_Imager_i_writegif)
{
    dXSARGS;
    if (items != 5)
	croak("Usage: Imager::i_writegif(im,fd,colors,pixdev,fixed)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	int	colors = (int)SvIV(ST(2));
	int	pixdev = (int)SvIV(ST(3));
#line 959 "Imager.xs"
             int     fixedlen;
	     Imager__Color  fixed;
	     Imager__Color  tmp;
	     AV* av;
	     SV* sv1;
             IV  Itmp;
	     int i;
#line 1852 "Imager.c"
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");
#line 967 "Imager.xs"
	     if (!SvROK(ST(4))) croak("Imager: Parameter 4 must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(4))) != SVt_PVAV) croak("Imager: Parameter 4 must be a reference to an array\n");
	     av=(AV*)SvRV(ST(4));
	     fixedlen=av_len(av)+1;
	     fixed=mymalloc( fixedlen*sizeof(i_color) );
	     for(i=0;i<fixedlen;i++) {
	       sv1=(*(av_fetch(av,i,0)));
               if (sv_derived_from(sv1, "Imager::Color")) {
                 Itmp = SvIV((SV*)SvRV(sv1));
                 tmp = (i_color*) Itmp;
               } else croak("Imager: one of the elements of array ref is not of Imager::Color type\n");
               fixed[i]=*tmp;
	     }
	     RETVAL=i_writegif(im,fd,colors,pixdev,fixedlen,fixed);
             myfree(fixed);
             ST(0) = sv_newmortal();
             if (RETVAL == 0) ST(0)=&PL_sv_undef;
             else sv_setiv(ST(0), (IV)RETVAL);
#line 1880 "Imager.c"
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writegifmc)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::i_writegifmc(im,fd,colors)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	int	colors = (int)SvIV(ST(2));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_writegifmc(im, fd, colors);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writegifex)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_writegifex(im,fd)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_writegifex(im, fd);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writegif_gen)
{
    dXSARGS;
    if (items < 1)
	croak("Usage: Imager::i_writegif_gen(fd, ...)");
    {
	int	fd = (int)SvIV(ST(0));
#line 1005 "Imager.xs"
	i_quantize quant;
	i_gif_opts opts;
	i_img **imgs = NULL;
	int img_count;
	int i;
	HV *hv;
#line 1950 "Imager.c"
	undef_int	RETVAL;
#line 1012 "Imager.xs"
	if (items < 3)
	    croak("Usage: i_writegif_gen(fd,hashref, images...)");
	if (!SvROK(ST(1)) || ! SvTYPE(SvRV(ST(1))))
	    croak("i_writegif_gen: Second argument must be a hash ref");
	hv = (HV *)SvRV(ST(1));
	memset(&quant, 0, sizeof(quant));
	quant.mc_size = 256;
	quant.mc_colors = mymalloc(quant.mc_size * sizeof(i_color));
	memset(&opts, 0, sizeof(opts));
	handle_quant_opts(&quant, hv);
	handle_gif_opts(&opts, hv);
	img_count = items - 2;
	RETVAL = 1;
	if (img_count < 1) {
	  RETVAL = 0;
	}
	else {
          imgs = mymalloc(sizeof(i_img *) * img_count);
          for (i = 0; i < img_count; ++i) {
	    SV *sv = ST(2+i);
	    imgs[i] = NULL;
	    if (SvROK(sv) && sv_derived_from(sv, "Imager::ImgRaw")) {
	      imgs[i] = (i_img *)SvIV((SV*)SvRV(sv));
	    }
	    else {
	      RETVAL = 0;
	      break;
            }
	  }
          if (RETVAL) {
	    RETVAL = i_writegif_gen(&quant, fd, imgs, img_count, &opts);
          }
	  myfree(imgs);
          if (RETVAL) {
	    copy_colors_back(hv, &quant);
          }
	}
             ST(0) = sv_newmortal();
             if (RETVAL == 0) ST(0)=&PL_sv_undef;
             else sv_setiv(ST(0), (IV)RETVAL);
#line 1993 "Imager.c"
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writegif_callback)
{
    dXSARGS;
    if (items < 2)
	croak("Usage: Imager::i_writegif_callback(cb, maxbuffer,...)");
    {
	int	maxbuffer = (int)SvIV(ST(1));
#line 1058 "Imager.xs"
	i_quantize quant;
	i_gif_opts opts;
	i_img **imgs = NULL;
	int img_count;
	int i;
	HV *hv;
        i_writer_data wd;
#line 2013 "Imager.c"
	undef_int	RETVAL;
#line 1066 "Imager.xs"
	if (items < 4)
	    croak("Usage: i_writegif_callback(\\&callback,maxbuffer,hashref, images...)");
	if (!SvROK(ST(2)) || ! SvTYPE(SvRV(ST(2))))
	    croak("i_writegif_callback: Second argument must be a hash ref");
	hv = (HV *)SvRV(ST(2));
	memset(&quant, 0, sizeof(quant));
	quant.mc_size = 256;
	quant.mc_colors = mymalloc(quant.mc_size * sizeof(i_color));
	memset(&opts, 0, sizeof(opts));
	handle_quant_opts(&quant, hv);
	handle_gif_opts(&opts, hv);
	img_count = items - 3;
	RETVAL = 1;
	if (img_count < 1) {
	  RETVAL = 0;
	}
	else {
          imgs = mymalloc(sizeof(i_img *) * img_count);
          for (i = 0; i < img_count; ++i) {
	    SV *sv = ST(3+i);
	    imgs[i] = NULL;
	    if (SvROK(sv) && sv_derived_from(sv, "Imager::ImgRaw")) {
	      imgs[i] = (i_img *)SvIV((SV*)SvRV(sv));
	    }
	    else {
	      RETVAL = 0;
	      break;
            }
	  }
          if (RETVAL) {
	    wd.sv = ST(0);
	    RETVAL = i_writegif_callback(&quant, write_callback, (char *)&wd, maxbuffer, imgs, img_count, &opts);
          }
	  myfree(imgs);
          if (RETVAL) {
	    copy_colors_back(hv, &quant);
          }
	}
             ST(0) = sv_newmortal();
             if (RETVAL == 0) ST(0)=&PL_sv_undef;
             else sv_setiv(ST(0), (IV)RETVAL);
#line 2057 "Imager.c"
    }
    XSRETURN(1);
}

XS(XS_Imager_i_readgif)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_readgif(fd)");
    SP -= items;
    {
	int	fd = (int)SvIV(ST(0));
#line 1112 "Imager.xs"
	        int*    colour_table;
	        int     colours, q, w;
	      i_img*    rimg;
                 SV*    temp[3];
                 AV*    ct; 
                 SV*    r;
#line 2077 "Imager.c"
#line 1119 "Imager.xs"
 	       colour_table=NULL;
               colours=0;

	if(GIMME_V == G_ARRAY) {  
            rimg=i_readgif(fd,&colour_table,&colours);
        } else {
            /* don't waste time with colours if they aren't wanted */
            rimg=i_readgif(fd,NULL,NULL);
        }

	if (colour_table == NULL) {
            EXTEND(SP,1);
            r=sv_newmortal();
            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
            PUSHs(r);
	} else {
            /* the following creates an [[r,g,b], [r, g, b], [r, g, b]...] */
            /* I don't know if I have the reference counts right or not :( */
            /* Neither do I :-) */
            ct=newAV();
            av_extend(ct, colours);
            for(q=0; q<colours; q++) {
                for(w=0; w<3; w++)
                    temp[w]=sv_2mortal(newSViv(colour_table[q*3 + w]));
                av_store(ct, q, (SV*)newRV_noinc((SV*)av_make(3, temp)));
            }
            myfree(colour_table);

            EXTEND(SP,2);
            r=sv_newmortal();
            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
            PUSHs(r);
            PUSHs(newRV_noinc((SV*)ct));
        }
#line 2113 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_readgif_scalar)
{
    dXSARGS;
    SP -= items;
    {
#line 1162 "Imager.xs"
               char*    data;
	        int     length;
	        int*    colour_table;
	        int     colours, q, w;
	      i_img*    rimg;
                 SV*    temp[3];
                 AV*    ct; 
                 SV*    r;
#line 2133 "Imager.c"
#line 1171 "Imager.xs"
        data = (char *)SvPV(ST(0),length);
        colour_table=NULL;
        colours=0;

	if(GIMME_V == G_ARRAY) {  
            rimg=i_readgif_scalar(data,length,&colour_table,&colours);
        } else {
            /* don't waste time with colours if they aren't wanted */
            rimg=i_readgif_scalar(data,length,NULL,NULL);
        }

	if (colour_table == NULL) {
            EXTEND(SP,1);
            r=sv_newmortal();
            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
            PUSHs(r);
	} else {
            /* the following creates an [[r,g,b], [r, g, b], [r, g, b]...] */
            /* I don't know if I have the reference counts right or not :( */
            /* Neither do I :-) */
            ct=newAV();
            av_extend(ct, colours);
            for(q=0; q<colours; q++) {
                for(w=0; w<3; w++)
                    temp[w]=sv_2mortal(newSViv(colour_table[q*3 + w]));
                av_store(ct, q, (SV*)newRV_noinc((SV*)av_make(3, temp)));
            }
            myfree(colour_table);

            EXTEND(SP,2);
            r=sv_newmortal();
            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
            PUSHs(r);
            PUSHs(newRV_noinc((SV*)ct));
        }
#line 2170 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_i_readgif_callback)
{
    dXSARGS;
    SP -= items;
    {
#line 1211 "Imager.xs"
               char*    data;
	        int     length;
	        int*    colour_table;
	        int     colours, q, w;
	      i_img*    rimg;
                 SV*    temp[3];
                 AV*    ct; 
                 SV*    r;
       i_reader_data    rd;
#line 2191 "Imager.c"
#line 1221 "Imager.xs"
	rd.sv = ST(0);
        colour_table=NULL;
        colours=0;

	if(GIMME_V == G_ARRAY) {  
            rimg=i_readgif_callback(read_callback, (char *)&rd,&colour_table,&colours);
        } else {
            /* don't waste time with colours if they aren't wanted */
            rimg=i_readgif_callback(read_callback, (char *)&rd,NULL,NULL);
        }

	if (colour_table == NULL) {
            EXTEND(SP,1);
            r=sv_newmortal();
            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
            PUSHs(r);
	} else {
            /* the following creates an [[r,g,b], [r, g, b], [r, g, b]...] */
            /* I don't know if I have the reference counts right or not :( */
            /* Neither do I :-) */
            /* Neither do I - maybe I'll move this somewhere */
            ct=newAV();
            av_extend(ct, colours);
            for(q=0; q<colours; q++) {
                for(w=0; w<3; w++)
                    temp[w]=sv_2mortal(newSViv(colour_table[q*3 + w]));
                av_store(ct, q, (SV*)newRV_noinc((SV*)av_make(3, temp)));
            }
            myfree(colour_table);

            EXTEND(SP,2);
            r=sv_newmortal();
            sv_setref_pv(r, "Imager::ImgRaw", (void*)rimg);
            PUSHs(r);
            PUSHs(newRV_noinc((SV*)ct));
        }
#line 2229 "Imager.c"
	PUTBACK;
	return;
    }
}

#endif
XS(XS_Imager_i_readppm)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_readppm(fd)");
    {
	int	fd = (int)SvIV(ST(0));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_readppm(fd);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writeppm)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_writeppm(im,fd)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_writeppm(im, fd);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_readraw)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_readraw(fd,x,y,datachannels,storechannels,intrl)");
    {
	int	fd = (int)SvIV(ST(0));
	int	x = (int)SvIV(ST(1));
	int	y = (int)SvIV(ST(2));
	int	datachannels = (int)SvIV(ST(3));
	int	storechannels = (int)SvIV(ST(4));
	int	intrl = (int)SvIV(ST(5));
	Imager__ImgRaw	RETVAL;

	RETVAL = i_readraw(fd, x, y, datachannels, storechannels, intrl);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_writeraw)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_writeraw(im,fd)");
    {
	Imager__ImgRaw	im;
	int	fd = (int)SvIV(ST(1));
	undef_int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_writeraw(im, fd);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_scaleaxis)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::i_scaleaxis(im,Value,Axis)");
    {
	Imager__ImgRaw	im;
	float	Value = (float)SvNV(ST(1));
	int	Axis = (int)SvIV(ST(2));
	Imager__ImgRaw	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_scaleaxis(im, Value, Axis);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_scale_nn)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::i_scale_nn(im,scx,scy)");
    {
	Imager__ImgRaw	im;
	float	scx = (float)SvNV(ST(1));
	float	scy = (float)SvNV(ST(2));
	Imager__ImgRaw	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_scale_nn(im, scx, scy);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_haar)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_haar(im)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_haar(im);
	ST(0) = sv_newmortal();
	sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_count_colors)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_count_colors(im,maxc)");
    {
	Imager__ImgRaw	im;
	int	maxc = (int)SvIV(ST(1));
	int	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	RETVAL = i_count_colors(im, maxc);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_i_transform)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_transform(im,opx,opy,parm)");
    {
	Imager__ImgRaw	im;
#line 1318 "Imager.xs"
             double* parm;
             int*    opx;
             int*    opy;
             int     opxl;
             int     opyl;
             int     parmlen;
             AV* av;
             SV* sv1;
             int i;
#line 2437 "Imager.c"
	Imager__ImgRaw	RETVAL;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");
#line 1328 "Imager.xs"
             if (!SvROK(ST(1))) croak("Imager: Parameter 1 must be a reference to an array\n");
             if (!SvROK(ST(2))) croak("Imager: Parameter 2 must be a reference to an array\n");
             if (!SvROK(ST(3))) croak("Imager: Parameter 3 must be a reference to an array\n");
             if (SvTYPE(SvRV(ST(1))) != SVt_PVAV) croak("Imager: Parameter 1 must be a reference to an array\n");
             if (SvTYPE(SvRV(ST(2))) != SVt_PVAV) croak("Imager: Parameter 2 must be a reference to an array\n");
             if (SvTYPE(SvRV(ST(3))) != SVt_PVAV) croak("Imager: Parameter 3 must be a reference to an array\n");
             av=(AV*)SvRV(ST(1));
             opxl=av_len(av)+1;
             opx=mymalloc( opxl*sizeof(int) );
             for(i=0;i<opxl;i++) {
               sv1=(*(av_fetch(av,i,0)));
               opx[i]=(int)SvIV(sv1);
             }
             av=(AV*)SvRV(ST(2));
             opyl=av_len(av)+1;
             opy=mymalloc( opyl*sizeof(int) );
             for(i=0;i<opyl;i++) {
               sv1=(*(av_fetch(av,i,0)));
               opy[i]=(int)SvIV(sv1);
             }
             av=(AV*)SvRV(ST(3));
             parmlen=av_len(av)+1;
             parm=mymalloc( parmlen*sizeof(double) );
             for(i=0;i<parmlen;i++) { /* TONYC's bug */
               sv1=(*(av_fetch(av,i,0)));
               parm[i]=(double)SvNV(sv1);
             }
             RETVAL=i_transform(im,opx,opxl,opy,opyl,parm,parmlen);
             myfree(parm);
             myfree(opy);
             myfree(opx);
             ST(0) = sv_newmortal();
             if (RETVAL == 0) ST(0)=&PL_sv_undef;
             else sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
#line 2481 "Imager.c"
    }
    XSRETURN(1);
}

XS(XS_Imager_i_transform2)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_transform2(width,height,ops,n_regs,c_regs,in_imgs)");
    {
#line 1366 "Imager.xs"
             int width;
             int height;
	     double* parm;
	     struct rm_op *ops;
	     int ops_len;
	     int ops_count;
             double *n_regs;
             int n_regs_count;
             i_color *c_regs;
	     int c_regs_count;
             int in_imgs_count;
             i_img **in_imgs;
	     AV* av;
	     SV* sv1;
             IV tmp;
	     int i;
#line 2509 "Imager.c"
	Imager__ImgRaw	RETVAL;
#line 1383 "Imager.xs"
	     if (!SvROK(ST(3))) croak("Imager: Parameter 4 must be a reference to an array\n");
	     if (!SvROK(ST(4))) croak("Imager: Parameter 5 must be a reference to an array\n");
	     if (!SvROK(ST(5))) croak("Imager: Parameter 6 must be a reference to an array of images\n");
	     if (SvTYPE(SvRV(ST(3))) != SVt_PVAV) croak("Imager: Parameter 4 must be a reference to an array\n");
	     if (SvTYPE(SvRV(ST(4))) != SVt_PVAV) croak("Imager: Parameter 5 must be a reference to an array\n");
/*if (SvTYPE(SvRV(ST(5))) != SVt_PVAV) croak("Imager: Parameter 6 must be a reference to an array\n");*/

             if (SvTYPE(SvRV(ST(5))) == SVt_PVAV) {
	       av = (AV*)SvRV(ST(5));
               in_imgs_count = av_len(av)+1;
	       for (i = 0; i < in_imgs_count; ++i) {
		 sv1 = *av_fetch(av, i, 0);
		 if (!sv_derived_from(sv1, "Imager::ImgRaw")) {
		   croak("Parameter 5 must contain only images");
		 }
	       }
	     }
	     else {
	       in_imgs_count = 0;
             }
             if (SvTYPE(SvRV(ST(5))) == SVt_PVAV) {
               av = (AV*)SvRV(ST(5));
               in_imgs = mymalloc(in_imgs_count*sizeof(i_img*));
               for (i = 0; i < in_imgs_count; ++i) {              
	         sv1 = *av_fetch(av,i,0);
	         if (!sv_derived_from(sv1, "Imager::ImgRaw")) {
		   croak("Parameter 5 must contain only images");
	         }
                 tmp = SvIV((SV*)SvRV(sv1));
	         in_imgs[i] = (i_img*)tmp;
	       }
	     }
             else {
	       /* no input images */
	       in_imgs = NULL;
             }
             /* default the output size from the first input if possible */
             if (SvOK(ST(0)))
	       width = SvIV(ST(0));
             else if (in_imgs_count)
	       width = in_imgs[0]->xsize;
             else
	       croak("No output image width supplied");

             if (SvOK(ST(1)))
	       height = SvIV(ST(1));
             else if (in_imgs_count)
	       height = in_imgs[0]->ysize;
             else
	       croak("No output image height supplied");

	     ops = (struct rm_op *)SvPV(ST(2), ops_len);
             if (ops_len % sizeof(struct rm_op))
	         croak("Imager: Parameter 3 must be a bitmap of regops\n");
	     ops_count = ops_len / sizeof(struct rm_op);
	     av = (AV*)SvRV(ST(3));
	     n_regs_count = av_len(av)+1;
             n_regs = mymalloc(n_regs_count * sizeof(double));
	     for (i = 0; i < n_regs_count; ++i) {
	       sv1 = *av_fetch(av,i,0);
	       if (SvOK(sv1))
	         n_regs[i] = SvNV(sv1);
	     }
             av = (AV*)SvRV(ST(4));
             c_regs_count = av_len(av)+1;
             c_regs = mymalloc(c_regs_count * sizeof(i_color));
             /* I don't bother initializing the colou?r registers */

	     RETVAL=i_transform2(width, height, 3, ops, ops_count, 
				 n_regs, n_regs_count, 
				 c_regs, c_regs_count, in_imgs, in_imgs_count);
	     if (in_imgs)
	         myfree(in_imgs);
             myfree(n_regs);
	     myfree(c_regs);
             ST(0) = sv_newmortal();
             if (RETVAL == 0) ST(0)=&PL_sv_undef;
             else sv_setref_pv(ST(0), "Imager::ImgRaw", (void*)RETVAL);
#line 2590 "Imager.c"
    }
    XSRETURN(1);
}

XS(XS_Imager_i_contrast)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_contrast(im,intensity)");
    {
	Imager__ImgRaw	im;
	float	intensity = (float)SvNV(ST(1));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_contrast(im, intensity);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_hardinvert)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::i_hardinvert(im)");
    {
	Imager__ImgRaw	im;

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_hardinvert(im);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_noise)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::i_noise(im,amount,type)");
    {
	Imager__ImgRaw	im;
	float	amount = (float)SvNV(ST(1));
	unsigned char	type = (unsigned char)SvUV(ST(2));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_noise(im, amount, type);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_bumpmap)
{
    dXSARGS;
    if (items != 6)
	croak("Usage: Imager::i_bumpmap(im,bump,channel,light_x,light_y,strength)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	bump;
	int	channel = (int)SvIV(ST(2));
	int	light_x = (int)SvIV(ST(3));
	int	light_y = (int)SvIV(ST(4));
	int	strength = (int)SvIV(ST(5));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    bump = (Imager__ImgRaw) tmp;
	}
	else
	    croak("bump is not of type Imager::ImgRaw");

	i_bumpmap(im, bump, channel, light_x, light_y, strength);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_postlevels)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_postlevels(im,levels)");
    {
	Imager__ImgRaw	im;
	int	levels = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_postlevels(im, levels);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_mosaic)
{
    dXSARGS;
    if (items != 2)
	croak("Usage: Imager::i_mosaic(im,size)");
    {
	Imager__ImgRaw	im;
	int	size = (int)SvIV(ST(1));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_mosaic(im, size);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_watermark)
{
    dXSARGS;
    if (items != 5)
	croak("Usage: Imager::i_watermark(im,wmark,tx,ty,pixdiff)");
    {
	Imager__ImgRaw	im;
	Imager__ImgRaw	wmark;
	int	tx = (int)SvIV(ST(2));
	int	ty = (int)SvIV(ST(3));
	int	pixdiff = (int)SvIV(ST(4));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	if (sv_derived_from(ST(1), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    wmark = (Imager__ImgRaw) tmp;
	}
	else
	    croak("wmark is not of type Imager::ImgRaw");

	i_watermark(im, wmark, tx, ty, pixdiff);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_autolevels)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_autolevels(im,lsat,usat,skew)");
    {
	Imager__ImgRaw	im;
	float	lsat = (float)SvNV(ST(1));
	float	usat = (float)SvNV(ST(2));
	float	skew = (float)SvNV(ST(3));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_autolevels(im, lsat, usat, skew);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_radnoise)
{
    dXSARGS;
    if (items != 5)
	croak("Usage: Imager::i_radnoise(im,xo,yo,rscale,ascale)");
    {
	Imager__ImgRaw	im;
	float	xo = (float)SvNV(ST(1));
	float	yo = (float)SvNV(ST(2));
	float	rscale = (float)SvNV(ST(3));
	float	ascale = (float)SvNV(ST(4));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_radnoise(im, xo, yo, rscale, ascale);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_i_turbnoise)
{
    dXSARGS;
    if (items != 4)
	croak("Usage: Imager::i_turbnoise(im,xo,yo,scale)");
    {
	Imager__ImgRaw	im;
	float	xo = (float)SvNV(ST(1));
	float	yo = (float)SvNV(ST(2));
	float	scale = (float)SvNV(ST(3));

	if (sv_derived_from(ST(0), "Imager::ImgRaw")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    im = (Imager__ImgRaw) tmp;
	}
	else
	    croak("im is not of type Imager::ImgRaw");

	i_turbnoise(im, xo, yo, scale);
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_malloc_state)
{
    dXSARGS;
    if (items != 0)
	croak("Usage: Imager::malloc_state()");
    {

	malloc_state();
    }
    XSRETURN_EMPTY;
}

XS(XS_Imager_hashinfo)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::hashinfo(hv)");
    SP -= items;
    {
#line 1536 "Imager.xs"
	       HV* hv;
	       int stuff;
#line 2855 "Imager.c"
#line 1539 "Imager.xs"
	       if (!SvROK(ST(0))) croak("Imager: Parameter 0 must be a reference to a hash\n");	       
	       hv=(HV*)SvRV(ST(0));
	       if (SvTYPE(hv)!=SVt_PVHV) croak("Imager: Parameter 0 must be a reference to a hash\n");
	       if (getint(hv,"stuff",&stuff)) printf("ok: %d\n",stuff); else printf("key doesn't exist\n");
	       if (getint(hv,"stuff2",&stuff)) printf("ok: %d\n",stuff); else printf("key doesn't exist\n");
#line 2862 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_DSO_open)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::DSO_open(filename)");
    SP -= items;
    {
	char*	filename = (char *)SvPV(ST(0),PL_na);
#line 1549 "Imager.xs"
	       void *rc;
	       char *evstr;
#line 2879 "Imager.c"
#line 1552 "Imager.xs"
	       rc=DSO_open(filename,&evstr);
               if (rc!=NULL) {
                 if (evstr!=NULL) {
                   EXTEND(SP,2); 
                   PUSHs(sv_2mortal(newSViv((IV)rc)));
                   PUSHs(sv_2mortal(newSVpvn(evstr, strlen(evstr))));
                 } else {
                   EXTEND(SP,1);
                   PUSHs(sv_2mortal(newSViv((IV)rc)));
                 }
               }
#line 2892 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_DSO_close)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::DSO_close(dso_handle)");
    {
	void*	dso_handle = (void *)SvIV(ST(0));
	undef_int	RETVAL;

	RETVAL = DSO_close(dso_handle);
	ST(0) = sv_newmortal();
	if (RETVAL == 0) ST(0)=&PL_sv_undef;
	else sv_setiv(ST(0), (IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_Imager_DSO_funclist)
{
    dXSARGS;
    if (items != 1)
	croak("Usage: Imager::DSO_funclist(dso_handle_v)");
    SP -= items;
    {
	void*	dso_handle_v = (void *)SvIV(ST(0));
#line 1573 "Imager.xs"
	       int i;
	       DSO_handle *dso_handle;
#line 2926 "Imager.c"
#line 1576 "Imager.xs"
	       dso_handle=(DSO_handle*)dso_handle_v;
	       i=0;
	       while( dso_handle->function_list[i].name != NULL) {
	         EXTEND(SP,1);
		 PUSHs(sv_2mortal(newSVpv(dso_handle->function_list[i].name,0)));
	         EXTEND(SP,1);
		 PUSHs(sv_2mortal(newSVpv(dso_handle->function_list[i++].pcode,0)));
	       }
#line 2936 "Imager.c"
	PUTBACK;
	return;
    }
}

XS(XS_Imager_DSO_call)
{
    dXSARGS;
    if (items != 3)
	croak("Usage: Imager::DSO_call(handle,func_index,hv)");
    SP -= items;
    {
	void*	handle = (void *)SvIV(ST(0));
	int	func_index = (int)SvIV(ST(1));
#line 1591 "Imager.xs"
	       HV* hv;
#line 2953 "Imager.c"
#line 1593 "Imager.xs"
	       if (!SvROK(ST(2))) croak("Imager: Parameter 2 must be a reference to a hash\n");	       
	       hv=(HV*)SvRV(ST(2));
	       if (SvTYPE(hv)!=SVt_PVHV) croak("Imager: Parameter 2 must be a reference to a hash\n");
	       DSO_call( (DSO_handle *)handle,func_index,hv);
#line 2959 "Imager.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Imager)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("Imager::Color::DESTROY", XS_Imager__Color_DESTROY, file);
        newXS("Imager::ImgRaw::new", XS_Imager__ImgRaw_new, file);
        newXS("Imager::ImgRaw::DESTROY", XS_Imager__ImgRaw_DESTROY, file);
        newXSproto("Imager::i_color_new", XS_Imager_i_color_new, file, "$$$$");
        newXSproto("Imager::i_color_set", XS_Imager_i_color_set, file, "$$$$$");
        newXSproto("Imager::i_color_info", XS_Imager_i_color_info, file, "$");
        newXSproto("Imager::i_list_formats", XS_Imager_i_list_formats, file, "");
        newXSproto("Imager::i_has_format", XS_Imager_i_has_format, file, "$");
        newXSproto("Imager::i_img_new", XS_Imager_i_img_new, file, "");
        newXSproto("Imager::i_img_empty", XS_Imager_i_img_empty, file, "$$$");
        newXSproto("Imager::i_img_empty_ch", XS_Imager_i_img_empty_ch, file, "$$$$");
        newXSproto("Imager::init_log", XS_Imager_init_log, file, "$$");
        newXSproto("Imager::i_img_exorcise", XS_Imager_i_img_exorcise, file, "$");
        newXSproto("Imager::i_img_destroy", XS_Imager_i_img_destroy, file, "$");
        newXSproto("Imager::i_img_info", XS_Imager_i_img_info, file, "$");
        newXSproto("Imager::i_img_setmask", XS_Imager_i_img_setmask, file, "$$");
        newXSproto("Imager::i_img_getmask", XS_Imager_i_img_getmask, file, "$");
        newXSproto("Imager::i_img_getchannels", XS_Imager_i_img_getchannels, file, "$");
        newXSproto("Imager::i_draw", XS_Imager_i_draw, file, "$$$$$$");
        newXSproto("Imager::i_line_aa", XS_Imager_i_line_aa, file, "$$$$$$");
        newXSproto("Imager::i_box", XS_Imager_i_box, file, "$$$$$$");
        newXSproto("Imager::i_box_filled", XS_Imager_i_box_filled, file, "$$$$$$");
        newXSproto("Imager::i_arc", XS_Imager_i_arc, file, "$$$$$$$");
        newXSproto("Imager::i_bezier_multi", XS_Imager_i_bezier_multi, file, "$$$$");
        newXSproto("Imager::i_poly_aa", XS_Imager_i_poly_aa, file, "$$$$");
        newXSproto("Imager::i_flood_fill", XS_Imager_i_flood_fill, file, "$$$$");
        newXSproto("Imager::i_copyto", XS_Imager_i_copyto, file, "$$$$$$$$");
        newXSproto("Imager::i_copyto_trans", XS_Imager_i_copyto_trans, file, "$$$$$$$$$");
        newXSproto("Imager::i_copy", XS_Imager_i_copy, file, "$$");
        newXSproto("Imager::i_rubthru", XS_Imager_i_rubthru, file, "$$$$");
        newXSproto("Imager::i_gaussian", XS_Imager_i_gaussian, file, "$$");
        newXSproto("Imager::i_conv", XS_Imager_i_conv, file, "$$");
        newXSproto("Imager::i_img_diff", XS_Imager_i_img_diff, file, "$$");
        newXSproto("Imager::i_init_fonts", XS_Imager_i_init_fonts, file, "");
#if XSubPPtmpAAAA
        newXSproto("Imager::i_t1_set_aa", XS_Imager_i_t1_set_aa, file, "$");
        newXSproto("Imager::i_t1_new", XS_Imager_i_t1_new, file, "$;$");
        newXSproto("Imager::i_t1_destroy", XS_Imager_i_t1_destroy, file, "$");
        newXSproto("Imager::i_t1_cp", XS_Imager_i_t1_cp, file, "$$$$$$$$$");
        newXSproto("Imager::i_t1_bbox", XS_Imager_i_t1_bbox, file, "$$$$");
        newXSproto("Imager::i_t1_text", XS_Imager_i_t1_text, file, "$$$$$$$$$");
#endif
#if XSubPPtmpAAAB
        newXSproto("Imager::i_tt_new", XS_Imager_i_tt_new, file, "$");
        newXSproto("Imager::i_tt_destroy", XS_Imager_i_tt_destroy, file, "$");
        newXSproto("Imager::i_tt_text", XS_Imager_i_tt_text, file, "$$$$$$$$$");
        newXSproto("Imager::i_tt_cp", XS_Imager_i_tt_cp, file, "$$$$$$$$$");
        newXSproto("Imager::i_tt_bbox", XS_Imager_i_tt_bbox, file, "$$$$");
#endif
#if XSubPPtmpAAAC
        newXSproto("Imager::i_writejpeg", XS_Imager_i_writejpeg, file, "$$$");
        newXSproto("Imager::i_readjpeg", XS_Imager_i_readjpeg, file, "$");
        newXSproto("Imager::i_readjpeg_scalar", XS_Imager_i_readjpeg_scalar, file, "$");
#endif
#if XSubPPtmpAAAD
        newXSproto("Imager::i_readpng", XS_Imager_i_readpng, file, "$");
        newXSproto("Imager::i_writepng", XS_Imager_i_writepng, file, "$$");
        newXSproto("Imager::i_readpng_scalar", XS_Imager_i_readpng_scalar, file, "$");
#endif
#if XSubPPtmpAAAE
        newXSproto("Imager::i_writegif", XS_Imager_i_writegif, file, "$$$$$");
        newXSproto("Imager::i_writegifmc", XS_Imager_i_writegifmc, file, "$$$");
        newXSproto("Imager::i_writegifex", XS_Imager_i_writegifex, file, "$$");
        newXSproto("Imager::i_writegif_gen", XS_Imager_i_writegif_gen, file, "$$@");
        newXSproto("Imager::i_writegif_callback", XS_Imager_i_writegif_callback, file, "&$$@");
        newXSproto("Imager::i_readgif", XS_Imager_i_readgif, file, "$");
        newXSproto("Imager::i_readgif_scalar", XS_Imager_i_readgif_scalar, file, "$");
        newXSproto("Imager::i_readgif_callback", XS_Imager_i_readgif_callback, file, "&");
#endif
        newXSproto("Imager::i_readppm", XS_Imager_i_readppm, file, "$");
        newXSproto("Imager::i_writeppm", XS_Imager_i_writeppm, file, "$$");
        newXSproto("Imager::i_readraw", XS_Imager_i_readraw, file, "$$$$$$");
        newXSproto("Imager::i_writeraw", XS_Imager_i_writeraw, file, "$$");
        newXSproto("Imager::i_scaleaxis", XS_Imager_i_scaleaxis, file, "$$$");
        newXSproto("Imager::i_scale_nn", XS_Imager_i_scale_nn, file, "$$$");
        newXSproto("Imager::i_haar", XS_Imager_i_haar, file, "$");
        newXSproto("Imager::i_count_colors", XS_Imager_i_count_colors, file, "$$");
        newXSproto("Imager::i_transform", XS_Imager_i_transform, file, "$$$$");
        newXSproto("Imager::i_transform2", XS_Imager_i_transform2, file, "$$$$$$");
        newXSproto("Imager::i_contrast", XS_Imager_i_contrast, file, "$$");
        newXSproto("Imager::i_hardinvert", XS_Imager_i_hardinvert, file, "$");
        newXSproto("Imager::i_noise", XS_Imager_i_noise, file, "$$$");
        newXSproto("Imager::i_bumpmap", XS_Imager_i_bumpmap, file, "$$$$$$");
        newXSproto("Imager::i_postlevels", XS_Imager_i_postlevels, file, "$$");
        newXSproto("Imager::i_mosaic", XS_Imager_i_mosaic, file, "$$");
        newXSproto("Imager::i_watermark", XS_Imager_i_watermark, file, "$$$$$");
        newXSproto("Imager::i_autolevels", XS_Imager_i_autolevels, file, "$$$$");
        newXSproto("Imager::i_radnoise", XS_Imager_i_radnoise, file, "$$$$$");
        newXSproto("Imager::i_turbnoise", XS_Imager_i_turbnoise, file, "$$$$");
        newXSproto("Imager::malloc_state", XS_Imager_malloc_state, file, "");
        newXSproto("Imager::hashinfo", XS_Imager_hashinfo, file, "$");
        newXSproto("Imager::DSO_open", XS_Imager_DSO_open, file, "$");
        newXSproto("Imager::DSO_close", XS_Imager_DSO_close, file, "$");
        newXSproto("Imager::DSO_funclist", XS_Imager_DSO_funclist, file, "$");
        newXSproto("Imager::DSO_call", XS_Imager_DSO_call, file, "$$$");

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#line 3083 "Imager.c"

    /* End of Initialisation Section */

    XSRETURN_YES;
}

